<?php
  ///////////////////////////////////////////////////
  // Система учёта посещаемости сайта - PowerCounter
  // 2003-2006 (C) IT-студия SoftTime (http://www.softtime.ru)
  // Поддержка: http://www.softtime.ru/forum/
  // Симдянов И.В. (simdyanov@softtime.ru)
  // Левин А.В. (loki_angel@mail.ru)
  // Кузнецов М.В. (kuznetsov@softtime.ru)
  // Голышев С.В. (softtime@softtime.ru)
  ///////////////////////////////////////////////////
  // Выставляем уровень обработки ошибок (http://www.softtime.ru/info/articlephp.php?id_article=23)
  Error_Reporting(E_ALL & ~E_NOTICE); 

// Функция архивации реффереров в суточные таблицы
function archive_refferer($tbl_refferer, $tbl_arch_refferer)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data FROM $tbl_refferer");
  if (!$dat) exit(mysql_error());
  $arr_date = mysql_fetch_array($dat);
  //Последнее полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y"));
  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate)) FROM $tbl_arch_refferer";
  $arh = mysql_query($query);
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из topcounter.php
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }
  //блок архивации
  if (ceil(($last_day - $last_date)/24/60/60))
  {
    $referer_number = REFFERER_NUMBER;

    $days = ceil(($last_day-$last_date)/24/60/60);
    for ($i = $days; $i>0; $i--)
    {
      // Вспомогательное условие
      $tmp = "putdate < '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL ".($i-1)." DAY AND
              putdate >= '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL $i DAY";

      // Извлекаем $ip_number самых активных IP-адресов за сутки
      $query_tbl_refferer = "SELECT name, COUNT(name) AS total FROM $tbl_refferer 
                             WHERE ".$tmp." 
                             GROUP BY name 
                             ORDER BY total DESC 
                             LIMIT $referer_number";

      $ref = mysql_query($query_tbl_refferer);
      if(!$ref) exit(mysql_error());

      // Формируем запрос для ахивации рефереров в таблицу $tbl_arch_ip
      while($referrer = mysql_fetch_array($ref))
      {
        $sql_referrer[] = "(NULL,
                            '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL ".($i-1)." DAY,
                            '$referrer[name]',
                            $referrer[total])";
      }
    }
    if(!empty($sql_referrer))
    {
      $query = "INSERT INTO $tbl_arch_refferer VALUES".implode(",", $sql_referrer);
      if(!mysql_query($query)) exit(mysql_error());
    }
  }
}


// Функция архивации рефереров в недельные таблицы
function archive_refferer_week($tbl_arch_refferer, $tbl_arch_refferer_week)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации дней
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data
                      FROM $tbl_arch_refferer");
  if (!$dat) exit(mysql_error());
  $arr_date = mysql_fetch_array($dat);

  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate_end)) FROM $tbl_arch_refferer_week";
  $arh = mysql_query($query);
  if(!$arh) exit(mysql_error());
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_arch_refferer
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }

  //Последней полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y"));
  // Вычисляем сколько недель прошло с даты последней архивации
  $week = floor(($last_day - $last_date)/24/60/60/7); 

  // Если прошло больше недели - архивируем данные
  if ($week > 0)
  {
    // $last_date - дата последней архивации... - смотрим далеко ли до
    // конца недели (воскресенье). Интервал включает данные с Понедельника (1)
    // до воскресенья (0).
    $weekday = date('w',$last_date);
    // Делаем так, чтобы воскресенье было 7, а понедельник 1
    // if($weekday === 0) $weekday = 7;

    $referer_number = REFFERER_NUMBER;

    // Текущему времени приравниваем начальную точку
    $current_date = $last_date;
    while(floor(($last_day - $current_date)/24/60/60/7))
    {
      // Вспомогательное условие
      $tmp = "putdate > '".date("Y-m-d 23:59:59", $current_date)."' AND
              putdate <= '" .date("Y-m-d 23:59:59", $current_date + 24*3600*(7 - $weekday))."'";

      // Извлекаем $ip_number самых активных IP-адресов за сутки
      $query_tbl_refferer = "SELECT name, SUM(total) AS total FROM $tbl_arch_refferer 
                             WHERE ".$tmp." 
                             GROUP BY name 
                             ORDER BY total DESC 
                             LIMIT $referer_number";

      $ref = mysql_query($query_tbl_refferer);
      if(!$ref) exit(mysql_error());

      // Формируем запрос для ахивации рефереров в таблицу $tbl_arch_refferer_week
      while($referrer = mysql_fetch_array($ref))
      {
        $sql_referrer[] = "(NULL,
                            '".date("Y-m-d 23:59:59", $current_date)."',
                            '".date("Y-m-d 23:59:59", $current_date + 24*3600*(7 - $weekday))."',
                            '$referrer[name]',
                            $referrer[total])";
      }

      // Увеличиваем текущее время до следующей недели
      $current_date += (7 - $weekday)*24*3600;
      $weekday = 0; // Далее идут циклы по целой недели
      // echo date("Y-m-d 23:59:59", $current_date)."<br>";
    }

    // Формируем окончательный запрос и выполняем его
    if(!empty($sql_referrer))
    {
      $query = "INSERT INTO $tbl_arch_refferer_week VALUES".implode(",", $sql_referrer);
      if(!mysql_query($query)) exit(mysql_error());
    }
  }
}


// Функция архивации рефереров в месячные таблицы
function archive_refferer_month($tbl_arch_refferer, $tbl_arch_refferer_month)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации дней
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data
                      FROM $tbl_arch_refferer");
  if (!$dat) exit(mysql_error());
  $arr_date = mysql_fetch_array($dat);

  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate + INTERVAL 1 MONTH)) 
            FROM $tbl_arch_refferer_month";
  $arh = mysql_query($query);
  if(!$arh) exit(mysql_error());
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_arch_refferer
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }

  //Последней полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y")) + 2;
  // Вычисляем сколько полных месяцев прошло с даты последней архивации
  $month = (floor(date("Y",$last_day) - date("Y",$last_date)))*12 + 
           floor(date("m",$last_day) - date("m",$last_date)); 

  // Если прошло больше месяца - архивируем данные
  if ($month > 0)
  {
    $referer_number = REFFERER_NUMBER;

    // Архивируем данные по всем месяцам, по которым архивация
    // не проводилась
    for($i = date("Y",$last_date)*12 + date("m",$last_date); $i < date("Y",$last_day)*12 + date("m",$last_day); $i++)
    {
      $year = (int)($i/12);
      $month = ($i%12);
      if($month == 0)
      {
        $year--;
        $month = 12;
      }
      // Вспомогательное условие
      $tmp = "YEAR(putdate) = $year AND
              MONTH(putdate) = '".sprintf("%02d",$month)."'";

      // Извлекаем $ip_number самых активных IP-адресов за сутки
      $query_tbl_refferer = "SELECT name, SUM(total) AS total FROM $tbl_arch_refferer 
                             WHERE ".$tmp." 
                             GROUP BY name 
                             ORDER BY total DESC 
                             LIMIT $referer_number";

      $ref = mysql_query($query_tbl_refferer);
      if(!$ref) exit(mysql_error());

      // Формируем запрос для ахивации рефереров в таблицу $tbl_arch_refferer_month
      while($referrer = mysql_fetch_array($ref))
      {
        $sql_referrer[] = "(NULL,
                            '$year-".sprintf("%02d",$month)."-01 23:59:59',
                            '$referrer[name]',
                            $referrer[total])";
      }
    }

    // Формируем окончательный запрос и выполняем его
    if(!empty($sql_referrer))
    {
      $query = "INSERT INTO $tbl_arch_refferer_month VALUES".implode(",", $sql_referrer);
      if(!mysql_query($query)) exit(mysql_error());
    }
  }
}
?>